import com.lowagie.text.pdf.*;
import com.lowagie.text.*;
//import org.bouncycastle.x509.*;
import java.security.cert.*;
//import java.security.*;
import java.security.KeyStore;
import java.security.PrivateKey;
import java.io.*;
import java.lang.System;

 public class sign {
 
   public static void main(String[] args) {

 try
 {

 KeyStore ks = KeyStore.getInstance("pkcs12");
 try
 {
  ks.load(new FileInputStream(args[0]), args[1].toCharArray());
 }
 catch(Exception e)
 {
   System.out.print("Fehler beim laden des Zertifikats!\n");
 }
 String alias = (String)ks.aliases().nextElement();
 PrivateKey key = (PrivateKey)ks.getKey(alias, args[1].toCharArray());
 Certificate[] chain = ks.getCertificateChain(alias);
 PdfReader reader = new PdfReader(args[2]);
 FileOutputStream fout = new FileOutputStream(args[3]);
 PdfStamper stp = PdfStamper.createSignature(reader, fout, '\0', new File("/tmp"));
 PdfSignatureAppearance sap = stp.getSignatureAppearance();
 sap.setCrypto(key, chain, null, PdfSignatureAppearance.WINCER_SIGNED);
 sap.setReason(args[4]);
 sap.setLocation(args[5]);
 // comment next line to have an invisible signature
 sap.setVisibleSignature(new Rectangle(100, 100, 300, 300), 1, null);
 stp.close();

  }
  catch(Exception e)
  {
  }

 }
}
